## toml11 3.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
enable_testing()

project(toml11 VERSION 3.7.0)

option(toml11_BUILD_TEST "Build toml tests" OFF)
option(toml11_TEST_WITH_ASAN  "use LLVM address sanitizer" OFF)
option(toml11_TEST_WITH_UBSAN "use LLVM undefined behavior sanitizer" OFF)

include(CheckCXXCompilerFlag)
if("${CMAKE_VERSION}" VERSION_GREATER 3.1)
    set(CMAKE_CXX_STANDARD 11 CACHE STRING "The C++ standard whose features are requested to build all targets.")
    set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Boolean describing whether the value of CXX_STANDARD is a requirement.")
    set(CMAKE_CXX_EXTENSIONS OFF CACHE BOOL "Boolean specifying whether compiler specific extensions are requested.")
else()
    # Manually check for C++11 compiler flag.
    CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
    CHECK_CXX_COMPILER_FLAG("-std=gnu++11" COMPILER_SUPPORTS_GNU11)
    CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" COMPILER_SUPPORTS_GNU0X)
    if(COMPILER_SUPPORTS_CXX11)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    elseif(COMPILER_SUPPORTS_CXXOX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    elseif(COMPILER_SUPPORTS_GNU11)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
    elseif(COMPILER_SUPPORTS_GNU0X)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++0x")
    else()
        if(MSVC)
            if(MSVC_VERSION LESS 1900)
                message(SEND_ERROR "MSVC < 14.0 is not supported. Please update your compiler or use mingw")
            endif()
        else()
            message(SEND_ERROR "The ${CMAKE_CXX_COMPILER} compiler lacks C++11 support. Use another compiler.")
        endif()
    endif()
endif()

if(MSVC)
    add_definitions("/Zc:__cplusplus")  # define __cplusplus value correctly
    add_definitions("/utf-8")           # enable to use u8"" literal
    if(MSVC_VERSION LESS 1910)
        message(STATUS "MSVC < 1910. DEFINE_CONVERSION_NON_INTRUSIVE is disabled")
        add_definitions(-DTOML11_WITHOUT_DEFINE_NON_INTRUSIVE)
    elseif(MSVC_VERSION LESS 1920)
        add_definitions("/experimental:preprocessor") # MSVC 2017
    else()
        add_definitions("/Zc:preprocessor") # MSVC 2019
    endif()
endif()

# Set some common directories
include(GNUInstallDirs)
set(toml11_install_cmake_dir         ${CMAKE_INSTALL_LIBDIR}/cmake/toml11)
set(toml11_install_include_dir       ${CMAKE_INSTALL_INCLUDEDIR})
set(toml11_config_dir                ${CMAKE_CURRENT_BINARY_DIR}/cmake/)
set(toml11_config                    ${toml11_config_dir}/toml11Config.cmake)
set(toml11_config_version            ${toml11_config_dir}/toml11ConfigVersion.cmake)

add_library(toml11 INTERFACE)
target_include_directories(toml11 INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${toml11_install_include_dir}>
)
add_library(toml11::toml11 ALIAS toml11)

# Write config and version config files
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${toml11_config_version}
    VERSION ${toml11_VERSION}
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
    cmake/toml11Config.cmake.in
    ${toml11_config}
    INSTALL_DESTINATION ${toml11_install_cmake_dir}
    PATH_VARS toml11_install_cmake_dir
)

# Install config files
install(FILES ${toml11_config} ${toml11_config_version}
    DESTINATION ${toml11_install_cmake_dir}
)

# Install header files
install(
    FILES toml.hpp
    DESTINATION "${toml11_install_include_dir}"
)
install(
    DIRECTORY "toml"
    DESTINATION "${toml11_install_include_dir}"
    FILES_MATCHING PATTERN "*.hpp"
)

# Export targets and install them
install(TARGETS toml11
    EXPORT toml11Targets
)
install(EXPORT toml11Targets
    FILE toml11Targets.cmake
    DESTINATION ${toml11_install_cmake_dir}
    NAMESPACE toml11::
)

if (toml11_BUILD_TEST)
    add_subdirectory(tests)
endif ()

=== tests/CMakeLists.txt ===
include(ExternalProject)
ExternalProject_Add(toml
        SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/toml
        GIT_REPOSITORY https://github.com/toml-lang/toml
        GIT_TAG v0.5.0
        CONFIGURE_COMMAND ""
        BUILD_COMMAND ""
        INSTALL_COMMAND "")

set(TEST_NAMES
    test_datetime
    test_string
    test_utility
    test_result
    test_traits
    test_value
    test_lex_boolean
    test_lex_integer
    test_lex_floating
    test_lex_datetime
    test_lex_string
    test_lex_key_comment
    test_parse_boolean
    test_parse_integer
    test_parse_floating
    test_parse_string
    test_parse_datetime
    test_parse_array
    test_parse_table
    test_parse_inline_table
    test_parse_key
    test_parse_table_key
    test_literals
    test_comments
    test_get
    test_get_or
    test_find
    test_find_or
    test_find_or_recursive
    test_expect
    test_parse_file
    test_serialize_file
    test_parse_unicode
    test_error_detection
    test_format_error
    test_extended_conversions
)

CHECK_CXX_COMPILER_FLAG("-Wall"      COMPILER_SUPPORTS_WALL)
CHECK_CXX_COMPILER_FLAG("-Wextra"    COMPILER_SUPPORTS_WEXTRA)
CHECK_CXX_COMPILER_FLAG("-Wpedantic" COMPILER_SUPPORTS_WPEDANTIC)
CHECK_CXX_COMPILER_FLAG("-Werror"    COMPILER_SUPPORTS_WERROR)

CHECK_CXX_COMPILER_FLAG("-Wsign-conversion"     COMPILER_SUPPORTS_WSIGN_CONVERSION)
CHECK_CXX_COMPILER_FLAG("-Wconversion"          COMPILER_SUPPORTS_WCONVERSION)
CHECK_CXX_COMPILER_FLAG("-Wduplicated-cond"     COMPILER_SUPPORTS_WDUPLICATED_COND)
CHECK_CXX_COMPILER_FLAG("-Wduplicated-branches" COMPILER_SUPPORTS_WDUPLICATED_BRANCHES)
CHECK_CXX_COMPILER_FLAG("-Wlogical-op"          COMPILER_SUPPORTS_WLOGICAL_OP)
CHECK_CXX_COMPILER_FLAG("-Wuseless-cast"        COMPILER_SUPPORTS_WUSELESS_CAST)
CHECK_CXX_COMPILER_FLAG("-Wdouble-promotion"    COMPILER_SUPPORTS_WDOUBLE_PROMOTION)
CHECK_CXX_COMPILER_FLAG("-Wrange-loop-analysis" COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS)
CHECK_CXX_COMPILER_FLAG("-Wundef"               COMPILER_SUPPORTS_WUNDEF)
CHECK_CXX_COMPILER_FLAG("-Wshadow"              COMPILER_SUPPORTS_WSHADOW)

if(COMPILER_SUPPORTS_WALL)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif()
if(COMPILER_SUPPORTS_WEXTRA)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
endif()
if(COMPILER_SUPPORTS_WPEDANTIC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpedantic")
endif()
if(COMPILER_SUPPORTS_WERROR)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()
if(COMPILER_SUPPORTS_WSHADOW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
endif()
if(COMPILER_SUPPORTS_WSIGN_CONVERSION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsign-conversion")
endif()
if(COMPILER_SUPPORTS_WCONVERSION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wconversion")
endif()
if(COMPILER_SUPPORTS_WDUPLICATED_COND)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wduplicated-cond")
endif()
if(COMPILER_SUPPORTS_WDUPLICATED_BRANCHES)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wduplicated-branches")
endif()
if(COMPILER_SUPPORTS_WLOGICAL_OP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
endif()
if(COMPILER_SUPPORTS_WUSELESS_CAST)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wuseless-cast")
endif()
if(COMPILER_SUPPORTS_WDOUBLE_PROMOTION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wdouble-promotion")
endif()
if(COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wrange-loop-analysis")
endif()
if(COMPILER_SUPPORTS_WUNDEF)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wundef")
endif()

option(TOML11_USE_UNRELEASED_TOML_FEATURES
    "use features in toml-lang/toml master while testing" OFF)

if(TOML11_USE_UNRELEASED_TOML_FEATURES)
    message(STATUS "adding TOML11_USE_UNRELEASED_TOML_FEATURES flag")
    add_definitions("-DTOML11_USE_UNRELEASED_TOML_FEATURES")
endif()

# Disable some MSVC warnings
if(MSVC)
    # conversion from 'double' to 'unsigned int', possible loss of data
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4244")
    # conversion from 'int' to 'unsigned int', signed/unsigned mismatch
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4365")
    # layout of class may have changed from a previous version of the compiler
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4371")
    # enumerator in switch of enum is not explicitly handled by a case label
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4061")
    # unreferenced inline function has been removed
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4514")
    # constructor is not implicitly called
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4582")
    # destructor is not implicitly called
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4583")
    # pragma warning: there is no warning number <x>
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4619")
    # default constructor was implicitly defined as deleted
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4623")
    # copy constructor was implicitly defined as deleted
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4625")
    # assignment operator was implicitly defined as deleted
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4626")
    # move assignment operator was implicitly defined as deleted
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4627")
    # <X> is not defined as a preprocessor macro, replacing with '0' for '#if/#elif'
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4668")
    # function not inlined
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4710")
    # function selected for automatic inlining
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4711")
    # <x> bytes padding added after data member
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4820")
    # pragma warning(pop): likely mismatch, popping warning state pushed in different file
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5031")
endif()

find_package(Boost COMPONENTS unit_test_framework REQUIRED)
add_definitions(-DBOOST_TEST_DYN_LINK)
add_definitions(-DUNITTEST_FRAMEWORK_LIBRARY_EXIST)

# check which standard library implementation is used. If libstdc++ is used,
# it will fail to compile. It compiles if libc++ is used.
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
#include <cstddef>
#ifdef __GLIBCXX__
    static_assert(false);
#endif
int main() {
    return 0;
}" TOML11_WITH_LIBCXX_LIBRARY)

# LLVM 8 requires -lc++fs if compiled with libc++ to use <filesystem>.
# LLVM 9+ does not require any special library.
# GCC 8 requires -lstdc++fs. GCC 9+ does not require it.
#
# Yes, we can check the version of the compiler used in the current build
# directly in CMake. But, in most cases, clang build uses libstdc++ as the
# standard library implementation and it makes the condition complicated.
# In many environment, the default installed C++ compiler is GCC and libstdc++
# is installed along with it. In most build on such an environment, even if we
# chose clang as the C++ compiler, still libstdc++ is used. Checking default
# gcc version makes the condition complicated.
# The purpose of this file is to compile tests. We know the environment on which
# the tests run. We can set this option and, I think, it is easier and better.
option(TOML11_REQUIRE_FILESYSTEM_LIBRARY "need to link -lstdc++fs or -lc++fs" OFF)

foreach(TEST_NAME ${TEST_NAMES})
    add_executable(${TEST_NAME} ${TEST_NAME}.cpp)
    target_link_libraries(${TEST_NAME} ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} toml11::toml11)

    # to compile tests with <filesystem>...
    if(TOML11_REQUIRE_FILESYSTEM_LIBRARY)
        if(TOML11_WITH_LIBCXX_LIBRARY)
            target_link_libraries(${TEST_NAME} "c++fs")
        else()
            target_link_libraries(${TEST_NAME} "stdc++fs")
        endif()
    endif()

    target_include_directories(${TEST_NAME} PRIVATE ${Boost_INCLUDE_DIRS})

    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        if(toml11_TEST_WITH_ASAN)
            set_target_properties(${TEST_NAME} PROPERTIES
                COMPILE_FLAGS "-fsanitize=address -fno-omit-frame-pointer"
                LINK_FLAGS    "-fsanitize=address -fno-omit-frame-pointer")
        elseif(toml11_TEST_WITH_UBSAN)
            set_target_properties(${TEST_NAME} PROPERTIES
                COMPILE_FLAGS "-fsanitize=undefined"
                LINK_FLAGS    "-fsanitize=undefined")
        endif()
    endif()

    add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    # Set the PATH to be able to find Boost DLL
    if(WIN32)
        STRING(REPLACE ";" "\\;" PATH_STRING "$ENV{PATH}")
        set_tests_properties(${TEST_NAME}
            PROPERTIES ENVIRONMENT "PATH=${PATH_STRING}\;${Boost_LIBRARY_DIRS}"
        )
    endif()
endforeach(TEST_NAME)


# this test is to check it compiles. it will not run
add_executable(test_multiple_translation_unit
               test_multiple_translation_unit_1.cpp
               test_multiple_translation_unit_2.cpp)
target_link_libraries(test_multiple_translation_unit toml11::toml11)

if(WIN32)
    add_executable(test_windows test_windows.cpp)
    target_link_libraries(test_windows toml11::toml11)
endif()

=== debian/changelog ===
toml11 (3.7.0-2) unstable; urgency=medium

  * Team upload.

  [ Lance Lin ]
  * Added autopkgtest files

  [ Andreas Tille ]
  * Source-only upload

 -- Andreas Tille <tille@debian.org>  Wed, 16 Feb 2022 12:16:46 +0100

toml11 (3.7.0-1) unstable; urgency=low

  * Initial release. Closes: #1004498

 -- Lance Lin <lqi254@protonmail.com>  Thu, 03 Feb 2022 20:22:26 +0700

=== debian/control ===
Source: toml11
Section: libdevel
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Lance Lin <lqi254@protonmail.com>
Build-Depends: cmake, debhelper-compat (= 13)
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/toml11
Vcs-Git: https://salsa.debian.org/med-team/toml11.git
Homepage: https://github.com/ToruNiina/toml11
Rules-Requires-Root: no

Package: libtoml11-dev
Architecture: all
Depends: ${misc:Depends}
Description: TOML parser/encoder
 toml11:
 It is compatible to the latest version of TOML v1.0.0.
 It is one of the most TOML standard compliant libraries, tested with the
 language agnostic test suite for TOML parsers by BurntSushi.
 It shows highly informative error messages. You can see the error messages
 about invalid files at CircleCI.
 It has configurable container. You can use any random-access containers
 and key-value maps as backend containers.
 It optionally preserves comments without any overhead.
 It has configurable serializer that supports comments, inline tables,
 literal strings and multiline strings.
 It supports user-defined type conversion from/into toml values.
 It correctly handles UTF-8 sequences, with or without BOM,
 both on posix and Windows.
 .
 This package contains the development header files.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	mkdir -p debian/`dh_listpackages`/usr/share/cmake
	mv debian/`dh_listpackages`/usr/lib/*/cmake/* debian/`dh_listpackages`/usr/share/cmake
	rm -rf debian/`dh_listpackages`/usr/lib

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/toml11-$1\.tar\.gz/ \
  https://github.com/ToruNiina/toml11/tags .*/v?(\d\S+)\.tar\.gz

## toml11 3.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,20 @@
 cmake_minimum_required(VERSION 3.1)
 enable_testing()
 
-project(toml11 VERSION 3.7.0)
+project(toml11 VERSION 3.7.1)
 
 option(toml11_BUILD_TEST "Build toml tests" OFF)
+option(toml11_INSTALL "Install CMake targets during install step." ON)
 option(toml11_TEST_WITH_ASAN  "use LLVM address sanitizer" OFF)
 option(toml11_TEST_WITH_UBSAN "use LLVM undefined behavior sanitizer" OFF)
 
 include(CheckCXXCompilerFlag)
 if("${CMAKE_VERSION}" VERSION_GREATER 3.1)
-    set(CMAKE_CXX_STANDARD 11 CACHE STRING "The C++ standard whose features are requested to build all targets.")
+    set(CMAKE_CXX_EXTENSIONS OFF CACHE BOOL "Boolean specifying whether compiler specific extensions are requested.")
+    if(NOT DEFINED CMAKE_CXX_STANDARD)
+        set(CMAKE_CXX_STANDARD 11 CACHE STRING "The C++ standard whose features are requested to build all targets.")
+    endif()
     set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Boolean describing whether the value of CXX_STANDARD is a requirement.")
-    set(CMAKE_CXX_EXTENSIONS OFF CACHE BOOL "Boolean specifying whether compiler specific extensions are requested.")
 else()
     # Manually check for C++11 compiler flag.
     CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
@@ -38,7 +41,7 @@
 endif()
 
 if(MSVC)
-    add_definitions("/Zc:__cplusplus")  # define __cplusplus value correctly
+#     add_definitions("/Zc:__cplusplus")  # define __cplusplus value correctly
     add_definitions("/utf-8")           # enable to use u8"" literal
     if(MSVC_VERSION LESS 1910)
         message(STATUS "MSVC < 1910. DEFINE_CONVERSION_NON_INTRUSIVE is disabled")
@@ -73,38 +76,40 @@
     COMPATIBILITY SameMajorVersion
 )
 
-configure_package_config_file(
-    cmake/toml11Config.cmake.in
-    ${toml11_config}
-    INSTALL_DESTINATION ${toml11_install_cmake_dir}
-    PATH_VARS toml11_install_cmake_dir
-)
+if (toml11_INSTALL)
+    configure_package_config_file(
+        cmake/toml11Config.cmake.in
+        ${toml11_config}
+        INSTALL_DESTINATION ${toml11_install_cmake_dir}
+        PATH_VARS toml11_install_cmake_dir
+    )
 
-# Install config files
-install(FILES ${toml11_config} ${toml11_config_version}
-    DESTINATION ${toml11_install_cmake_dir}
-)
+    # Install config files
+    install(FILES ${toml11_config} ${toml11_config_version}
+        DESTINATION ${toml11_install_cmake_dir}
+    )
 
-# Install header files
-install(
-    FILES toml.hpp
-    DESTINATION "${toml11_install_include_dir}"
-)
-install(
-    DIRECTORY "toml"
-    DESTINATION "${toml11_install_include_dir}"
-    FILES_MATCHING PATTERN "*.hpp"
-)
+    # Install header files
+    install(
+        FILES toml.hpp
+        DESTINATION "${toml11_install_include_dir}"
+    )
+    install(
+        DIRECTORY "toml"
+        DESTINATION "${toml11_install_include_dir}"
+        FILES_MATCHING PATTERN "*.hpp"
+    )
 
-# Export targets and install them
-install(TARGETS toml11
-    EXPORT toml11Targets
-)
-install(EXPORT toml11Targets
-    FILE toml11Targets.cmake
-    DESTINATION ${toml11_install_cmake_dir}
-    NAMESPACE toml11::
-)
+    # Export targets and install them
+    install(TARGETS toml11
+        EXPORT toml11Targets
+    )
+    install(EXPORT toml11Targets
+        FILE toml11Targets.cmake
+        DESTINATION ${toml11_install_cmake_dir}
+        NAMESPACE toml11::
+    )
+endif()
 
 if (toml11_BUILD_TEST)
     add_subdirectory(tests)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -149,6 +149,10 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4820")
     # pragma warning(pop): likely mismatch, popping warning state pushed in different file
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5031")
+	# pragma warning(pop): spectre warnings in tests
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd5045")
+	# pragma warning(pop): spectre warnings in tests
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4265")
 endif()
 
 find_package(Boost COMPONENTS unit_test_framework REQUIRED)
@@ -185,6 +189,7 @@
 foreach(TEST_NAME ${TEST_NAMES})
     add_executable(${TEST_NAME} ${TEST_NAME}.cpp)
     target_link_libraries(${TEST_NAME} ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} toml11::toml11)
+    target_include_directories(${TEST_NAME} SYSTEM PRIVATE ${Boost_INCLUDE_DIRS})
 
     # to compile tests with <filesystem>...
     if(TOML11_REQUIRE_FILESYSTEM_LIBRARY)

=== debian/changelog ===
toml11 (3.7.1-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * autopkgtest: Disable -Werror and run tests on all architectures

 -- Andreas Tille <tille@debian.org>  Fri, 13 May 2022 06:58:04 +0200

toml11 (3.7.1-2) unstable; urgency=medium

  * Team upload

  [ Adrian Bunk ]
  * Install the cmake files to the correct location, instead of moving the
    installed files

  [ Andreas Tille ]
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 12 May 2022 12:39:00 +0200

toml11 (3.7.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Skip autopkgtest for Architectures armhf and i386

 -- Andreas Tille <tille@debian.org>  Wed, 27 Apr 2022 10:15:52 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Lance Lin <lqi254@protonmail.com>
 Build-Depends: cmake, debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/toml11
 Vcs-Git: https://salsa.debian.org/med-team/toml11.git
 Homepage: https://github.com/ToruNiina/toml11
@@ -13,6 +13,7 @@
 Package: libtoml11-dev
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: TOML parser/encoder
  toml11:
  It is compatible to the latest version of TOML v1.0.0.

## toml11 3.8.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,23 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.5)
 enable_testing()
 
-project(toml11 VERSION 3.7.1)
+project(toml11 VERSION 3.8.1)
 
 option(toml11_BUILD_TEST "Build toml tests" OFF)
 option(toml11_INSTALL "Install CMake targets during install step." ON)
 option(toml11_TEST_WITH_ASAN  "use LLVM address sanitizer" OFF)
 option(toml11_TEST_WITH_UBSAN "use LLVM undefined behavior sanitizer" OFF)
 
+option(TOML11_USE_UNRELEASED_TOML_FEATURES
+    "use features in toml-lang/toml master while testing" OFF)
+
 include(CheckCXXCompilerFlag)
 if("${CMAKE_VERSION}" VERSION_GREATER 3.1)
     set(CMAKE_CXX_EXTENSIONS OFF CACHE BOOL "Boolean specifying whether compiler specific extensions are requested.")
     if(NOT DEFINED CMAKE_CXX_STANDARD)
-        set(CMAKE_CXX_STANDARD 11 CACHE STRING "The C++ standard whose features are requested to build all targets.")
+        message(FATAL_ERROR "CMAKE_CXX_STANDARD is not defined. \
+The C++ standard whose features are requested to *build* all targets. \
+Remember that toml11 is a header only library that does NOT require compilation to use.")
     endif()
     set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Boolean describing whether the value of CXX_STANDARD is a requirement.")
 else()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,20 @@
 include(ExternalProject)
-ExternalProject_Add(toml
-        SOURCE_DIR ${CMAKE_CURRENT_BINARY_DIR}/toml
-        GIT_REPOSITORY https://github.com/toml-lang/toml
-        GIT_TAG v0.5.0
+
+set(TOML11_LANGSPEC_GIT_REPOSITORY "https://github.com/toml-lang/toml" CACHE STRING
+    "URL of the TOML language specification repository")
+
+set(TOML11_LANGSPEC_SOURCE_DIR "${CMAKE_CURRENT_BINARY_DIR}/toml" CACHE FILEPATH
+    "directory for the TOML language specification tree")
+
+if(NOT EXISTS "${TOML11_LANGSPEC_SOURCE_DIR}/toml.abnf")
+    ExternalProject_Add(toml
+        SOURCE_DIR "${TOML11_LANGSPEC_SOURCE_DIR}"
+        GIT_REPOSITORY "${TOML11_LANGSPEC_GIT_REPOSITORY}"
+        GIT_TAG "v0.5.0"
         CONFIGURE_COMMAND ""
         BUILD_COMMAND ""
         INSTALL_COMMAND "")
+endif()
 
 set(TEST_NAMES
     test_datetime
@@ -62,6 +71,82 @@
 CHECK_CXX_COMPILER_FLAG("-Wundef"               COMPILER_SUPPORTS_WUNDEF)
 CHECK_CXX_COMPILER_FLAG("-Wshadow"              COMPILER_SUPPORTS_WSHADOW)
 
+include(CheckCXXSourceCompiles)
+
+# check which standard library implementation is used. If libstdc++ is used,
+# it will fail to compile. It compiles if libc++ is used.
+check_cxx_source_compiles("
+#include <cstddef>
+#ifdef __GLIBCXX__
+    static_assert(false);
+#endif
+int main() {
+    return 0;
+}" TOML11_WITH_LIBCXX_LIBRARY)
+
+# LLVM 8 requires -lc++fs if compiled with libc++ to use <filesystem>.
+# LLVM 9+ does not require any special library.
+# GCC 8 requires -lstdc++fs. GCC 9+ does not require it.
+#
+# Yes, we can check the version of the compiler used in the current build
+# directly in CMake. But, in most cases, clang build uses libstdc++ as the
+# standard library implementation and it makes the condition complicated.
+# In many environment, the default installed C++ compiler is GCC and libstdc++
+# is installed along with it. In most build on such an environment, even if we
+# chose clang as the C++ compiler, still libstdc++ is used. Checking default
+# gcc version makes the condition complicated.
+# The purpose of this file is to compile tests. We know the environment on which
+# the tests run. We can set this option and, I think, it is easier and better.
+option(TOML11_REQUIRE_FILESYSTEM_LIBRARY "need to link -lstdc++fs or -lc++fs" OFF)
+
+find_package(Boost COMPONENTS unit_test_framework REQUIRED)
+
+set(PREVIOUSLY_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES}")
+set(PREVIOUSLY_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
+
+list(APPEND CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
+list(APPEND CMAKE_REQUIRED_LIBRARIES ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
+
+check_cxx_source_compiles("
+#define BOOST_TEST_MODULE \"dummy\"
+#undef BOOST_TEST_DYN_LINK
+#define BOOST_TEST_NO_LIB
+#include <boost/test/included/unit_test.hpp>
+BOOST_AUTO_TEST_CASE(proforma) { BOOST_TEST(true); }
+" TOML11_WITH_BOOST_TEST_HEADER)
+
+check_cxx_source_compiles("
+#define BOOST_TEST_MODULE \"dummy\"
+#undef BOOST_TEST_DYN_LINK
+#undef BOOST_TEST_NO_LIB
+#include <boost/test/unit_test.hpp>
+BOOST_AUTO_TEST_CASE(proforma) { BOOST_TEST(true); }
+" TOML11_WITH_BOOST_TEST_STATIC)
+
+check_cxx_source_compiles("
+#define BOOST_TEST_MODULE \"dummy\"
+#define BOOST_TEST_DYN_LINK
+#undef BOOST_TEST_NO_LIB
+#include <boost/test/unit_test.hpp>
+BOOST_AUTO_TEST_CASE(proforma) { BOOST_TEST(true); }
+" TOML11_WITH_BOOST_TEST_DYNAMIC)
+
+set(CMAKE_REQUIRED_INCLUDES "${PREVIOUSLY_REQUIRED_INCLUDES}")
+set(CMAKE_REQUIRED_LIBRARIES "${PREVIOUSLY_REQUIRED_LIBRARIES}")
+
+unset(PREVIOUSLY_REQUIRED_INCLUDES)
+unset(PREVIOUSLY_REQUIRED_LIBRARIES)
+
+if(TOML11_WITH_BOOST_TEST_DYNAMIC)
+    add_definitions(-DUNITTEST_FRAMEWORK_LIBRARY_EXIST -DBOOST_TEST_DYN_LINK)
+elseif(TOML11_WITH_BOOST_TEST_STATIC)
+    add_definitions(-DUNITTEST_FRAMEWORK_LIBRARY_EXIST)
+elseif(TOML11_WITH_BOOST_TEST_HEADER)
+    add_definitions(-DBOOST_TEST_NO_LIB)
+else()
+    message(FATAL_ERROR "Neither the Boost.Test static or shared library nor the header-only version seem to be usable.")
+endif()
+
 if(COMPILER_SUPPORTS_WALL)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
 endif()
@@ -104,9 +189,6 @@
 if(COMPILER_SUPPORTS_WUNDEF)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wundef")
 endif()
-
-option(TOML11_USE_UNRELEASED_TOML_FEATURES
-    "use features in toml-lang/toml master while testing" OFF)
 
 if(TOML11_USE_UNRELEASED_TOML_FEATURES)
     message(STATUS "adding TOML11_USE_UNRELEASED_TOML_FEATURES flag")
@@ -155,41 +237,18 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4265")
 endif()
 
-find_package(Boost COMPONENTS unit_test_framework REQUIRED)
-add_definitions(-DBOOST_TEST_DYN_LINK)
-add_definitions(-DUNITTEST_FRAMEWORK_LIBRARY_EXIST)
-
-# check which standard library implementation is used. If libstdc++ is used,
-# it will fail to compile. It compiles if libc++ is used.
-include(CheckCXXSourceCompiles)
-check_cxx_source_compiles("
-#include <cstddef>
-#ifdef __GLIBCXX__
-    static_assert(false);
-#endif
-int main() {
-    return 0;
-}" TOML11_WITH_LIBCXX_LIBRARY)
-
-# LLVM 8 requires -lc++fs if compiled with libc++ to use <filesystem>.
-# LLVM 9+ does not require any special library.
-# GCC 8 requires -lstdc++fs. GCC 9+ does not require it.
-#
-# Yes, we can check the version of the compiler used in the current build
-# directly in CMake. But, in most cases, clang build uses libstdc++ as the
-# standard library implementation and it makes the condition complicated.
-# In many environment, the default installed C++ compiler is GCC and libstdc++
-# is installed along with it. In most build on such an environment, even if we
-# chose clang as the C++ compiler, still libstdc++ is used. Checking default
-# gcc version makes the condition complicated.
-# The purpose of this file is to compile tests. We know the environment on which
-# the tests run. We can set this option and, I think, it is easier and better.
-option(TOML11_REQUIRE_FILESYSTEM_LIBRARY "need to link -lstdc++fs or -lc++fs" OFF)
+set(TEST_ENVIRON "TOMLDIR=${TOML11_LANGSPEC_SOURCE_DIR}")
+if(WIN32)
+    # Set the PATH to be able to find Boost DLL
+    STRING(REPLACE ";" "\\;" PATH_STRING "$ENV{PATH}")
+    list(APPEND TEST_ENVIRON "PATH=${PATH_STRING}\;${Boost_LIBRARY_DIRS}")
+endif()
 
 foreach(TEST_NAME ${TEST_NAMES})
     add_executable(${TEST_NAME} ${TEST_NAME}.cpp)
     target_link_libraries(${TEST_NAME} ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} toml11::toml11)
     target_include_directories(${TEST_NAME} SYSTEM PRIVATE ${Boost_INCLUDE_DIRS})
+    target_compile_definitions(${TEST_NAME} PRIVATE "BOOST_TEST_MODULE=\"${TEST_NAME}\"")
 
     # to compile tests with <filesystem>...
     if(TOML11_REQUIRE_FILESYSTEM_LIBRARY)
@@ -215,14 +274,7 @@
     endif()
 
     add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
-
-    # Set the PATH to be able to find Boost DLL
-    if(WIN32)
-        STRING(REPLACE ";" "\\;" PATH_STRING "$ENV{PATH}")
-        set_tests_properties(${TEST_NAME}
-            PROPERTIES ENVIRONMENT "PATH=${PATH_STRING}\;${Boost_LIBRARY_DIRS}"
-        )
-    endif()
+    set_tests_properties(${TEST_NAME} PROPERTIES ENVIRONMENT "${TEST_ENVIRON}")
 endforeach(TEST_NAME)

=== debian/changelog ===
toml11 (3.8.1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * d/control: Update Uploaders email
  * d/rules: Set CMAKE_CXX_STANDARD for configuration
  * d/patches: Set Forwarded field for cmake-install.patch
  * d/tests/run-unit-test: Set CMAKE_CXX_STANDARD for configuration
  * d/copyright: Update copyright year and email for debian files

 -- Lance Lin <lq27267@gmail.com>  Fri, 12 Jan 2024 21:59:12 +0700

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: libdevel
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Lance Lin <lqi254@protonmail.com>
+Uploaders: Lance Lin <lq27267@gmail.com>
 Build-Depends: cmake, debhelper-compat (= 13)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/toml11
 Vcs-Git: https://salsa.debian.org/med-team/toml11.git
 Homepage: https://github.com/ToruNiina/toml11

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_CXX_STANDARD=11

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, cmake, build-essential, git, libboost-test-dev
Restrictions: allow-stderr
